import clingo
import copy 
import time
import sys
import re

# Observer to track: minimize literals
class enumication:
    def __init__(self, name):
        self.program_name = name
        self.my_models = []

    def main(self, ctl, files):
        if len(files) > 0:
            for f in files:
                ctl.load(f)
        else:
            ctl.load("-")

        # ===================================
        # Initialize
        assert(ctl.configuration.solve.opt_mode == 'enum')
        start = time.time()

        # ===================================
        # Ground and Solve
        ctl.ground([("base", [])])
        costs = []   
        with ctl.solve(yield_=True) as handle:
            for model in handle:
                costs = model.cost[0]
                self.my_models.append((costs, time.time() - start))
        self.my_models = sorted(self.my_models, key = lambda item : item[0])

                    
